/* QNT - clipb.cpp - Clipboard routines. */


#define WIN32_LEAN_AND_MEAN
#include <string.h>
#include <windows.h>
#include "clipb.h"


BOOL Clipb::put( char *buf )
{
    if( !OpenClipboard( NULL ) )
        return FALSE;
    EmptyClipboard();
    HGLOBAL hglb = GlobalAlloc( GMEM_DDESHARE, strlen( buf ) + 1 );
    if( !hglb )
    {
        CloseClipboard();
        return FALSE;
    }
    LPTSTR lptstr = (LPTSTR)GlobalLock( hglb );
    strcpy( lptstr, buf );
    GlobalUnlock( hglb );
    SetClipboardData( CF_TEXT, hglb );
    CloseClipboard();
    return TRUE;
}


char *Clipb::get()
{
    if( !IsClipboardFormatAvailable( CF_TEXT ) )
        return 0;
    if( !OpenClipboard( NULL ) )
        return 0;
    HGLOBAL hglb = GetClipboardData( CF_TEXT );
    char *buf = 0;
    if( hglb )
    {
        LPTSTR lptstr = (LPTSTR)GlobalLock( hglb );
        if( lptstr )
        {
            buf = new char[strlen( lptstr ) + 1];
            strcpy( buf, lptstr );
            GlobalUnlock( hglb );
        }
    }
    CloseClipboard();
    return buf;
}
