/* QNT - config.cpp - Configuration file :) */


#define WIN32_LEAN_AND_MEAN
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include "buffer.h"
#include "config.h"


int Config::pageoverlap = 1;
WORD Config::textattr = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
WORD Config::hiliteattr = FOREGROUND_INTENSITY | BACKGROUND_INTENSITY
    | BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE;
WORD Config::statusattr = BACKGROUND_GREEN | BACKGROUND_BLUE;

/* Time from first modification to autosave in milliseconds: */
DWORD Config::autosaveinterval = 60000;


int Config::shiftxform( int s )
{
    if( s & ALT ) return ALT;
    else if( s & CTRL ) return CTRL;
    else if( s & TOP ) return TOP;
    else if( s & META ) return META;
    else return 0;
}


char *Config::genstatusline( BOOL mod, int row, int col, char *fname )
{
    int len = strlen( fname );
    char *buf = new char[31 + len];
    memset( buf, ' ', 30 );
    if( mod )
        buf[0] = '*';
    buf[2] = 'R';
    itoa( row, buf + 4, 10 );
    char *ptr = buf + 4;
    while( *ptr )
        ptr++;
    ptr[0] = ' ';
    ptr[2] = 'C';
    ptr += 4;
    itoa( col, ptr, 10 );
    while( *ptr )
        ptr++;
    ptr[0] = ' ';
    memcpy( ptr + 2, fname, len + 1 );
    return buf;
}


Keys Config::keys[] =
{
    { VK_RETURN,            Buffer::enter },
    { SHIFT | VK_INSERT,    Buffer::paste },
    { SHIFT | VK_DELETE,    Buffer::cut },
    { VK_LEFT,              Buffer::charleft },
    { VK_RIGHT,             Buffer::charright },
    { VK_HOME,              Buffer::linebeg },
    { VK_END,               Buffer::lineend },
    { CTRL | VK_LEFT,       Buffer::wordleft },
    { CTRL | VK_RIGHT,      Buffer::wordright },
    { VK_BACK,              Buffer::delcharleftwrap },
    { VK_DELETE,            Buffer::delcharrightwrapsel },
    { CTRL | VK_BACK,       Buffer::dellinebeg },
    { CTRL | VK_DELETE,     Buffer::dellineend },
    { ALT | VK_BACK,        Buffer::delwordleft },
    { ALT | VK_DELETE,      Buffer::delwordright },
    { VK_UP,                Buffer::lineup },
    { VK_DOWN,              Buffer::linedown },
    { VK_PRIOR,             Buffer::pageup },
    { VK_NEXT,              Buffer::pagedown },
    { CTRL | VK_PRIOR,      Buffer::filebeg },
    { CTRL | VK_NEXT,       Buffer::fileend },
    { CTRL | 'K',           Buffer::delline },
    { CTRL | 'X',           Buffer::cut },
    { CTRL | 'C',           Buffer::copy },
    { CTRL | 'V',           Buffer::paste },
    { CTRL | VK_INSERT,     Buffer::copy },
    { VK_F2,                Buffer::save },
    { ALT | 'X',            Buffer::exit },
    { 0, 0 }
};
